Naviframe

- Main Page
- Related Pages
- Data Structures
- Files
- Examples

Functions
Naviframe

Naviframe stands for navigation frame. It's a views manager for applications. More...

## Functions
Evas_Object * | elm_naviframe_add (Evas_Object *parent)
| Add a new Naviframe object to the parent. More...
EINA_DEPRECATED void | elm_naviframe_item_title_visible_set (Elm_Object_Item *it, Eina_Bool visible)
| Show/Hide the title area. More...
EINA_DEPRECATED Eina_Bool | elm_naviframe_item_title_visible_get (const Elm_Object_Item *it)
| Get a value whether title area is visible or not. More...
EOAPI void | elm_obj_naviframe_event_enabled_set (Eina_Bool enabled)
| Set the event enabled when pushing/popping items. More...
EOAPI Eina_Bool | elm_obj_naviframe_event_enabled_get (void)
| Get the value of event enabled status. More...
EOAPI void | elm_obj_naviframe_content_preserve_on_pop_set (Eina_Bool preserve)
| preserve the content objects when items are popped. More...
EOAPI Eina_Bool | elm_obj_naviframe_content_preserve_on_pop_get (void)
| Get a value whether preserve mode is enabled or not. More...
EOAPI void | elm_obj_naviframe_prev_btn_auto_pushed_set (Eina_Bool auto_pushed)
| Set creating prev button automatically or not. More...
EOAPI Eina_Bool | elm_obj_naviframe_prev_btn_auto_pushed_get (void)
| Get a value whether prev button(back button) will be auto pushed or not. More...
EOAPI Eina_List * | elm_obj_naviframe_items_get (void)
| Get a list of all the naviframe items. More...
EOAPI Elm_Object_Item * | elm_obj_naviframe_top_item_get (void)
| Get a top item on the naviframe stack. More...
EOAPI Elm_Object_Item * | elm_obj_naviframe_bottom_item_get (void)
| Get a bottom item on the naviframe stack. More...
EOAPI Evas_Object * | elm_obj_naviframe_item_pop (void)
| Pop an item that is on top of the stack. More...
EOAPI Elm_Object_Item * | elm_obj_naviframe_item_insert_before (Elm_Object_Item *before, const char *title_label, Evas_Object *prev_btn, Evas_Object *next_btn, Evas_Object *content, const char *item_style)
| Insert a new item into the naviframe before item `before`. More...
EOAPI Elm_Object_Item * | elm_obj_naviframe_item_push (const char *title_label, Evas_Object *prev_btn, Evas_Object *next_btn, Evas_Object *content, const char *item_style)
| Push a new item to the top of the naviframe stack (and show it). More...
EOAPI Elm_Object_Item * | elm_obj_naviframe_item_insert_after (Elm_Object_Item *after, const char *title_label, Evas_Object *prev_btn, Evas_Object *next_btn, Evas_Object *content, const char *item_style)
| Insert a new item into the naviframe after item `after`. More...
void | elm_naviframe_event_enabled_set (Elm_Naviframe *obj, Eina_Bool enabled)
| Set the event enabled when pushing/popping items. More...
Eina_Bool | elm_naviframe_event_enabled_get (const Elm_Naviframe *obj)
| Get the value of event enabled status. More...
void | elm_naviframe_content_preserve_on_pop_set (Elm_Naviframe *obj, Eina_Bool preserve)
| preserve the content objects when items are popped. More...
Eina_Bool | elm_naviframe_content_preserve_on_pop_get (const Elm_Naviframe *obj)
| Get a value whether preserve mode is enabled or not. More...
void | elm_naviframe_prev_btn_auto_pushed_set (Elm_Naviframe *obj, Eina_Bool auto_pushed)
| Set creating prev button automatically or not. More...
Eina_Bool | elm_naviframe_prev_btn_auto_pushed_get (const Elm_Naviframe *obj)
| Get a value whether prev button(back button) will be auto pushed or not. More...
Eina_List * | elm_naviframe_items_get (const Elm_Naviframe *obj)
| Get a list of all the naviframe items. More...
Elm_Object_Item * | elm_naviframe_top_item_get (const Elm_Naviframe *obj)
| Get a top item on the naviframe stack. More...
Elm_Object_Item * | elm_naviframe_bottom_item_get (const Elm_Naviframe *obj)
| Get a bottom item on the naviframe stack. More...
Evas_Object * | elm_naviframe_item_pop (Elm_Naviframe *obj)
| Pop an item that is on top of the stack. More...
Elm_Object_Item * | elm_naviframe_item_insert_before (Elm_Naviframe *obj, Elm_Object_Item *before, const char *title_label, Evas_Object *prev_btn, Evas_Object *next_btn, Evas_Object *content, const char *item_style)
| Insert a new item into the naviframe before item `before`. More...
Elm_Object_Item * | elm_naviframe_item_push (Elm_Naviframe *obj, const char *title_label, Evas_Object *prev_btn, Evas_Object *next_btn, Evas_Object *content, const char *item_style)
| Push a new item to the top of the naviframe stack (and show it). More...
Elm_Object_Item * | elm_naviframe_item_insert_after (Elm_Naviframe *obj, Elm_Object_Item *after, const char *title_label, Evas_Object *prev_btn, Evas_Object *next_btn, Evas_Object *content, const char *item_style)
| Insert a new item into the naviframe after item `after`. More...
EOAPI void | elm_obj_naviframe_item_style_set (const char *style)
| Set an item style. More...
EOAPI const char * | elm_obj_naviframe_item_style_get (void)
| Get an item style. More...
EOAPI void | elm_obj_naviframe_item_pop_to (void)
| Pop the top item and delete the items between the top and the above one on the given item. More...
EOAPI Eina_Bool | elm_obj_naviframe_item_title_enabled_get (void)
| Get a value whether title area is enabled or not. More...
EOAPI void | elm_obj_naviframe_item_title_enabled_set (Eina_Bool enable, Eina_Bool transition)
| Enable/Disable the title area with transition effect. More...
EOAPI void | elm_obj_naviframe_item_pop_cb_set (Elm_Naviframe_Item_Pop_Cb func, void *data)
| Set a function to be called when `it` of the naviframe is going to be popped. More...
void | elm_naviframe_item_style_set (Elm_Naviframe_Item *obj, const char *style)
| Set an item style. More...
const char * | elm_naviframe_item_style_get (const Elm_Naviframe_Item *obj)
| Get an item style. More...
void | elm_naviframe_item_pop_to (Elm_Naviframe_Item *obj)
| Pop the top item and delete the items between the top and the above one on the given item. More...
Eina_Bool | elm_naviframe_item_title_enabled_get (const Elm_Naviframe_Item *obj)
| Get a value whether title area is enabled or not. More...
void | elm_naviframe_item_title_enabled_set (Elm_Naviframe_Item *obj, Eina_Bool enable, Eina_Bool transition)
| Enable/Disable the title area with transition effect. More...
void | elm_naviframe_item_pop_cb_set (Elm_Naviframe_Item *obj, Elm_Naviframe_Item_Pop_Cb func, void *data)
| Set a function to be called when `it` of the naviframe is going to be popped. More...

## Detailed Description

Naviframe stands for navigation frame. It's a views manager for applications.

A naviframe holds views (or pages) as its items. Those items are organized in a stack, so that new items get pushed on top of the old, and only the topmost view is displayed at one time. Due to the characteristics of a stack, even though you push a new item, previous item is not deleted. Previous item will be shown when you pop new item. The transition between views is animated, depending on the theme applied to the widget.

Naviframe views hold spaces to various elements, which are:

- back button, used to navigate to previous views,
- next button, used to navigate to next views in the stack,
- title label,
- sub-title label,
- title icon and
- content area.

One can use elm_object_item_part_content_set, elm_object_item_part_content_get, elm_object_item_part_content_unset functions to handle the contents. The swallow part name should be one of these:

- `"default"` - The main content of the current page
- `"icon"` - An icon in the title area of the current page
- `"prev_btn"` - A button of the current page to go to the previous page
- `"next_btn"` - A button of the current page to go to the next page

One can use elm_object_item_part_text_set, elm_object_item_part_text_get to handle the text parts. The swallow part name should be one of these:

- `"default"` - A title label in the title area of the current page
- `"subtitle"` - A sub-title label in the title area of the current page

Most of those content objects can be passed at the time of an item creation (see elm_naviframe_item_push()).

Naviframe items can have different styles, which affect the transition between views, for example. On the default theme, two of them are supported:

- `"basic"` - views are switched sliding horizontally, one after the other
- `"overlap"` - like the previous one, but the previous view stays at its place and is overlapped by the new

This widget emits the following signals, besides the ones sent from Layout:

- `"transition,finished"` - When the transition is finished in changing the item
- `"title,transition,finished"` - When the title area's transition is finished in changing the state of the title
- `"title,clicked"` - User clicked title area
- `"focused"` - When the naviframe has received focus. (since 1.8)
- `"unfocused"` - When the naviframe has lost focus. (since 1.8)
- `"language,changed"` - the program's language changed (since 1.9)

All the parts, for content and text, described here will also be reachable by naviframe items direct calls:

- elm_object_item_del
- elm_object_item_part_text_set
- elm_object_item_part_text_get
- elm_object_item_part_content_set
- elm_object_item_part_content_get
- elm_object_item_part_content_unset
- elm_object_item_signal_emit

What happens is that the topmost item of a naviframe will be the widget's target layout, when accessed directly. Items lying below the top one can be interacted with this way.

Here is an example on its usage:

- naviframe_example

## Function Documentation

Evas_Object* elm_naviframe_add | ( | Evas_Object * | parent | ) |

Add a new Naviframe object to the parent.

Parameters

  parent | Parent object

Returns
  New object or `NULL`, if it cannot be created

Elm_Object_Item* elm_naviframe_bottom_item_get | ( | const Elm_Naviframe * | obj | ) |

Get a bottom item on the naviframe stack.

Returns
  The bottom item on the naviframe stack or `NULL`, if the stack is empty

References elm_obj_naviframe_bottom_item_get().

Eina_Bool elm_naviframe_content_preserve_on_pop_get | ( | const Elm_Naviframe * | obj | ) |

Get a value whether preserve mode is enabled or not.

Returns
  If `EINA_TRUE`, preserve mode is enabled

See also
  also elm_naviframe_content_preserve_on_pop_set()

References elm_obj_naviframe_content_preserve_on_pop_get().

void elm_naviframe_content_preserve_on_pop_set | ( | Elm_Naviframe * | obj,
|  | Eina_Bool | preserve
| ) |  |

preserve the content objects when items are popped.

See also
  also elm_naviframe_content_preserve_on_pop_get()

Parameters

  [in] | preserve | Enable the preserve mode if `EINA_TRUE`, disable otherwise

References elm_obj_naviframe_content_preserve_on_pop_set().

Eina_Bool elm_naviframe_event_enabled_get | ( | const Elm_Naviframe * | obj | ) |

Get the value of event enabled status.

Returns
  `EINA_TRUE`, when event is enabled

See also
  elm_naviframe_event_enabled_set()

References elm_obj_naviframe_event_enabled_get().

void elm_naviframe_event_enabled_set | ( | Elm_Naviframe * | obj,
|  | Eina_Bool | enabled
| ) |  |

Set the event enabled when pushing/popping items.

If `enabled` is `EINA_TRUE`, the contents of the naviframe item will receives events from mouse and keyboard during view changing such as item push/pop.

Warning
  Events will be blocked by calling evas_object_freeze_events_set() internally. So don't call the API whiling pushing/popping items.

See also
  elm_naviframe_event_enabled_get()
  evas_object_freeze_events_set()

Parameters

  [in] | enabled | Events are received when enabled is `EINA_TRUE`, and ignored otherwise.

References elm_obj_naviframe_event_enabled_set().

Elm_Object_Item* elm_naviframe_item_insert_after | ( | Elm_Naviframe * | obj,
|  | Elm_Object_Item * | after,
|  | const char * | title_label,
|  | Evas_Object * | prev_btn,
|  | Evas_Object * | next_btn,
|  | Evas_Object * | content,
|  | const char * | item_style
| ) |  |

Insert a new item into the naviframe after item `after`.

Returns
  The created item or `NULL` upon failure.

The item is inserted into the naviframe straight away without any transition operations. This item will be deleted when it is popped.

See also
  also elm_naviframe_item_style_set()
  also elm_naviframe_item_push()
  also elm_naviframe_item_insert_before()

The following styles are available for this item:

- `"default"`

Parameters

  [in] | after | The naviframe item to insert after.
  [in] | title_label | The label in the title area. The name of the title label part is "elm.text.title"
  [in] | prev_btn | The button to go to the previous item. If it is NULL, then naviframe will create a back button automatically. The name of the prev_btn part is "elm.swallow.prev_btn"
  [in] | next_btn | The button to go to the next item. Or It could be just an extra function button. The name of the next_btn part is "elm.swallow.next_btn"
  [in] | content | The main content object. The name of content part is "elm.swallow.content"
  [in] | item_style | The current item style name. `NULL` would be default.

References elm_obj_naviframe_item_insert_after().

Elm_Object_Item* elm_naviframe_item_insert_before | ( | Elm_Naviframe * | obj,
|  | Elm_Object_Item * | before,
|  | const char * | title_label,
|  | Evas_Object * | prev_btn,
|  | Evas_Object * | next_btn,
|  | Evas_Object * | content,
|  | const char * | item_style
| ) |  |

Insert a new item into the naviframe before item `before`.

Returns
  The created item or `NULL` upon failure.

The item is inserted into the naviframe straight away without any transition operations. This item will be deleted when it is popped.

See also
  also elm_naviframe_item_style_set()
  also elm_naviframe_item_push()
  also elm_naviframe_item_insert_after()

The following styles are available for this item:

- `"default"`

Parameters

  [in] | before | The naviframe item to insert before.
  [in] | title_label | The label in the title area. The name of the title label part is "elm.text.title"
  [in] | prev_btn | The button to go to the previous item. If it is NULL, then naviframe will create a back button automatically. The name of the prev_btn part is "elm.swallow.prev_btn"
  [in] | next_btn | The button to go to the next item. Or It could be just an extra function button. The name of the next_btn part is "elm.swallow.next_btn"
  [in] | content | The main content object. The name of content part is "elm.swallow.content"
  [in] | item_style | The current item style name. `NULL` would be default.

References elm_obj_naviframe_item_insert_before().

Evas_Object* elm_naviframe_item_pop | ( | Elm_Naviframe * | obj | ) |

Pop an item that is on top of the stack.

Returns
  `NULL` or the content object(if the elm_naviframe_content_preserve_on_pop_get is true).

This pops an item that is on the top(visible) of the naviframe, makes it disappear, then deletes the item. The item that was underneath it on the stack will become visible.

See also
  also elm_naviframe_content_preserve_on_pop_get()
  also elm_naviframe_item_pop_cb_set()

References elm_obj_naviframe_item_pop().

void elm_naviframe_item_pop_cb_set | ( | Elm_Naviframe_Item * | obj,
|  | Elm_Naviframe_Item_Pop_Cb | func,
|  | void * | data
| ) |  |

Set a function to be called when `it` of the naviframe is going to be popped.

Parameters

  func | the callback function.

Warning
  Don't set "clicked" callback to the prev button additionally if the function does an exact same logic with this `func`. When hardware back key is pressed then both callbacks will be called.

Since
  1.8

Parameters

  [in] | func | The callback function
  [in] | data | Data to be passed to func call

References elm_obj_naviframe_item_pop_cb_set().

void elm_naviframe_item_pop_to | ( | Elm_Naviframe_Item * | obj | ) |

Pop the top item and delete the items between the top and the above one on the given item.

The items between the top and the given item will be deleted first, and then the top item will be popped at last.

References elm_obj_naviframe_item_pop_to().

Elm_Object_Item* elm_naviframe_item_push | ( | Elm_Naviframe * | obj,
|  | const char * | title_label,
|  | Evas_Object * | prev_btn,
|  | Evas_Object * | next_btn,
|  | Evas_Object * | content,
|  | const char * | item_style
| ) |  |

Push a new item to the top of the naviframe stack (and show it).

Returns
  The created item or `NULL` upon failure.

The item pushed becomes one page of the naviframe, this item will be deleted when it is popped.

See also
  also elm_naviframe_item_style_set()
  also elm_naviframe_item_insert_before()
  also elm_naviframe_item_insert_after()

The following styles are available for this item:

- `"default"`

Parameters

  [in] | title_label | The label in the title area. The name of the title label part is "elm.text.title"
  [in] | prev_btn | The button to go to the previous item. If it is NULL, then naviframe will create a back button automatically. The name of the prev_btn part is "elm.swallow.prev_btn"
  [in] | next_btn | The button to go to the next item. Or It could be just an extra function button. The name of the next_btn part is "elm.swallow.next_btn"
  [in] | content | The main content object. The name of content part is "elm.swallow.content"
  [in] | item_style | The current item style name. `NULL` would be default.

References elm_obj_naviframe_item_push().

const char* elm_naviframe_item_style_get | ( | const Elm_Naviframe_Item * | obj | ) |

Get an item style.

See also
  also elm_naviframe_item_style_set()

References elm_obj_naviframe_item_style_get().

void elm_naviframe_item_style_set | ( | Elm_Naviframe_Item * | obj,
|  | const char * | style
| ) |  |

Set an item style.

The following styles are available for this item:

- `"default"`

See also
  also elm_naviframe_item_style_get()

Parameters

  [in] | style | The current item style name. `NULL` would be default

References elm_obj_naviframe_item_style_set().

Eina_Bool elm_naviframe_item_title_enabled_get | ( | const Elm_Naviframe_Item * | obj | ) |

Get a value whether title area is enabled or not.

See also
  also elm_naviframe_item_title_enabled_set()

References elm_obj_naviframe_item_title_enabled_get().

Referenced by elm_naviframe_item_title_visible_get().

void elm_naviframe_item_title_enabled_set | ( | Elm_Naviframe_Item * | obj,
|  | Eina_Bool | enable,
|  | Eina_Bool | transition
| ) |  |

Enable/Disable the title area with transition effect.

When the title area is disabled, then the controls would be hidden so as to expand the content area to full-size.

See also
  also elm_naviframe_item_title_enabled_get()
  also elm_naviframe_item_title_visible_set()

Parameters

  [in] | enable | If `EINA_TRUE`, title area will be enabled, disabled otherwise
  [in] | transition | If `EINA_TRUE`, transition effect of the title will be visible, invisible otherwise

References elm_obj_naviframe_item_title_enabled_set().

Referenced by elm_naviframe_item_title_visible_set().

EINA_DEPRECATED Eina_Bool elm_naviframe_item_title_visible_get | ( | const Elm_Object_Item * | it | ) |

Get a value whether title area is visible or not.

Parameters

  it | The naviframe item

Returns
  If `EINA_TRUE`, title area is visible

Deprecated:
  Use elm_naviframe_item_title_enabled_get() instead.

See also
  also elm_naviframe_item_title_visible_set()

References elm_naviframe_item_title_enabled_get().

EINA_DEPRECATED void elm_naviframe_item_title_visible_set | ( | Elm_Object_Item * | it,
|  | Eina_Bool | visible
| ) |  |

Show/Hide the title area.

Parameters

  it | The naviframe item
  visible | If `EINA_TRUE`, title area will be visible, hidden otherwise

When the title area is invisible, then the controls would be hidden so as to expand the content area to full-size.

Deprecated:
  Use elm_naviframe_item_title_enabled_set() instead.

See also
  also elm_naviframe_item_title_visible_get()
  also elm_naviframe_item_title_enabled_get()

References elm_naviframe_item_title_enabled_set().

Eina_List* elm_naviframe_items_get | ( | const Elm_Naviframe * | obj | ) |

Get a list of all the naviframe items.

Returns
  A list of naviframe items, Elm_Object_Item, or `NULL` on failure.

Note
  The returned list MUST be freed.

References elm_obj_naviframe_items_get().

Eina_Bool elm_naviframe_prev_btn_auto_pushed_get | ( | const Elm_Naviframe * | obj | ) |

Get a value whether prev button(back button) will be auto pushed or not.

Returns
  If `EINA_TRUE`, prev button will be auto pushed.

See also
  also elm_naviframe_item_push() elm_naviframe_prev_btn_auto_pushed_set()

References elm_obj_naviframe_prev_btn_auto_pushed_get().

void elm_naviframe_prev_btn_auto_pushed_set | ( | Elm_Naviframe * | obj,
|  | Eina_Bool | auto_pushed
| ) |  |

Set creating prev button automatically or not.

See also
  also elm_naviframe_item_push()

Parameters

  [in] | auto_pushed | If `EINA_TRUE`, the previous button(back button) will be created internally when you pass the `NULL` to the prev_btn parameter in elm_naviframe_item_push

References elm_obj_naviframe_prev_btn_auto_pushed_set().

Elm_Object_Item* elm_naviframe_top_item_get | ( | const Elm_Naviframe * | obj | ) |

Get a top item on the naviframe stack.

Returns
  The top item on the naviframe stack or `NULL`, if the stack is empty

References elm_obj_naviframe_top_item_get().

EOAPI Elm_Object_Item* elm_obj_naviframe_bottom_item_get | ( | void |  | ) |

Get a bottom item on the naviframe stack.

Returns
  The bottom item on the naviframe stack or `NULL`, if the stack is empty

Referenced by elm_naviframe_bottom_item_get().

EOAPI Eina_Bool elm_obj_naviframe_content_preserve_on_pop_get | ( | void |  | ) |

Get a value whether preserve mode is enabled or not.

Returns
  If `EINA_TRUE`, preserve mode is enabled

See also
  also elm_naviframe_content_preserve_on_pop_set()

Referenced by elm_naviframe_content_preserve_on_pop_get().

EOAPI void elm_obj_naviframe_content_preserve_on_pop_set | ( | Eina_Bool | preserve | ) |

preserve the content objects when items are popped.

See also
  also elm_naviframe_content_preserve_on_pop_get()

Parameters

  [in] | preserve | Enable the preserve mode if `EINA_TRUE`, disable otherwise

Referenced by elm_naviframe_content_preserve_on_pop_set().

EOAPI Eina_Bool elm_obj_naviframe_event_enabled_get | ( | void |  | ) |

Get the value of event enabled status.

Returns
  `EINA_TRUE`, when event is enabled

See also
  elm_naviframe_event_enabled_set()

Referenced by elm_naviframe_event_enabled_get().

EOAPI void elm_obj_naviframe_event_enabled_set | ( | Eina_Bool | enabled | ) |

Set the event enabled when pushing/popping items.

If `enabled` is `EINA_TRUE`, the contents of the naviframe item will receives events from mouse and keyboard during view changing such as item push/pop.

Warning
  Events will be blocked by calling evas_object_freeze_events_set() internally. So don't call the API whiling pushing/popping items.

See also
  elm_naviframe_event_enabled_get()
  evas_object_freeze_events_set()

Parameters

  [in] | enabled | Events are received when enabled is `EINA_TRUE`, and ignored otherwise.

Referenced by elm_naviframe_event_enabled_set().

EOAPI Elm_Object_Item* elm_obj_naviframe_item_insert_after | ( | Elm_Object_Item * | after,
|  | const char * | title_label,
|  | Evas_Object * | prev_btn,
|  | Evas_Object * | next_btn,
|  | Evas_Object * | content,
|  | const char * | item_style
| ) |  |

Insert a new item into the naviframe after item `after`.

Returns
  The created item or `NULL` upon failure.

The item is inserted into the naviframe straight away without any transition operations. This item will be deleted when it is popped.

See also
  also elm_naviframe_item_style_set()
  also elm_naviframe_item_push()
  also elm_naviframe_item_insert_before()

The following styles are available for this item:

- `"default"`

Parameters

  [in] | after | The naviframe item to insert after.
  [in] | title_label | The label in the title area. The name of the title label part is "elm.text.title"
  [in] | prev_btn | The button to go to the previous item. If it is NULL, then naviframe will create a back button automatically. The name of the prev_btn part is "elm.swallow.prev_btn"
  [in] | next_btn | The button to go to the next item. Or It could be just an extra function button. The name of the next_btn part is "elm.swallow.next_btn"
  [in] | content | The main content object. The name of content part is "elm.swallow.content"
  [in] | item_style | The current item style name. `NULL` would be default.

Referenced by elm_naviframe_item_insert_after().

EOAPI Elm_Object_Item* elm_obj_naviframe_item_insert_before | ( | Elm_Object_Item * | before,
|  | const char * | title_label,
|  | Evas_Object * | prev_btn,
|  | Evas_Object * | next_btn,
|  | Evas_Object * | content,
|  | const char * | item_style
| ) |  |

Insert a new item into the naviframe before item `before`.

Returns
  The created item or `NULL` upon failure.

The item is inserted into the naviframe straight away without any transition operations. This item will be deleted when it is popped.

See also
  also elm_naviframe_item_style_set()
  also elm_naviframe_item_push()
  also elm_naviframe_item_insert_after()

The following styles are available for this item:

- `"default"`

Parameters

  [in] | before | The naviframe item to insert before.
  [in] | title_label | The label in the title area. The name of the title label part is "elm.text.title"
  [in] | prev_btn | The button to go to the previous item. If it is NULL, then naviframe will create a back button automatically. The name of the prev_btn part is "elm.swallow.prev_btn"
  [in] | next_btn | The button to go to the next item. Or It could be just an extra function button. The name of the next_btn part is "elm.swallow.next_btn"
  [in] | content | The main content object. The name of content part is "elm.swallow.content"
  [in] | item_style | The current item style name. `NULL` would be default.

Referenced by elm_naviframe_item_insert_before().

EOAPI Evas_Object* elm_obj_naviframe_item_pop | ( | void |  | ) |

Pop an item that is on top of the stack.

Returns
  `NULL` or the content object(if the elm_naviframe_content_preserve_on_pop_get is true).

This pops an item that is on the top(visible) of the naviframe, makes it disappear, then deletes the item. The item that was underneath it on the stack will become visible.

See also
  also elm_naviframe_content_preserve_on_pop_get()
  also elm_naviframe_item_pop_cb_set()

Referenced by elm_naviframe_item_pop().

EOAPI void elm_obj_naviframe_item_pop_cb_set | ( | Elm_Naviframe_Item_Pop_Cb | func,
|  | void * | data
| ) |  |

Set a function to be called when `it` of the naviframe is going to be popped.

Parameters

  func | the callback function.

Warning
  Don't set "clicked" callback to the prev button additionally if the function does an exact same logic with this `func`. When hardware back key is pressed then both callbacks will be called.

Since
  1.8

Parameters

  [in] | func | The callback function
  [in] | data | Data to be passed to func call

Referenced by elm_naviframe_item_pop_cb_set().

EOAPI void elm_obj_naviframe_item_pop_to | ( | void |  | ) |

Pop the top item and delete the items between the top and the above one on the given item.

The items between the top and the given item will be deleted first, and then the top item will be popped at last.

Referenced by elm_naviframe_item_pop_to().

EOAPI Elm_Object_Item* elm_obj_naviframe_item_push | ( | const char * | title_label,
|  | Evas_Object * | prev_btn,
|  | Evas_Object * | next_btn,
|  | Evas_Object * | content,
|  | const char * | item_style
| ) |  |

Push a new item to the top of the naviframe stack (and show it).

Returns
  The created item or `NULL` upon failure.

The item pushed becomes one page of the naviframe, this item will be deleted when it is popped.

See also
  also elm_naviframe_item_style_set()
  also elm_naviframe_item_insert_before()
  also elm_naviframe_item_insert_after()

The following styles are available for this item:

- `"default"`

Parameters

  [in] | title_label | The label in the title area. The name of the title label part is "elm.text.title"
  [in] | prev_btn | The button to go to the previous item. If it is NULL, then naviframe will create a back button automatically. The name of the prev_btn part is "elm.swallow.prev_btn"
  [in] | next_btn | The button to go to the next item. Or It could be just an extra function button. The name of the next_btn part is "elm.swallow.next_btn"
  [in] | content | The main content object. The name of content part is "elm.swallow.content"
  [in] | item_style | The current item style name. `NULL` would be default.

Referenced by elm_naviframe_item_push().

EOAPI const char* elm_obj_naviframe_item_style_get | ( | void |  | ) |

Get an item style.

See also
  also elm_naviframe_item_style_set()

Referenced by elm_naviframe_item_style_get().

EOAPI void elm_obj_naviframe_item_style_set | ( | const char * | style | ) |

Set an item style.

The following styles are available for this item:

- `"default"`

See also
  also elm_naviframe_item_style_get()

Parameters

  [in] | style | The current item style name. `NULL` would be default

Referenced by elm_naviframe_item_style_set().

EOAPI Eina_Bool elm_obj_naviframe_item_title_enabled_get | ( | void |  | ) |

Get a value whether title area is enabled or not.

See also
  also elm_naviframe_item_title_enabled_set()

Referenced by elm_naviframe_item_title_enabled_get().

EOAPI void elm_obj_naviframe_item_title_enabled_set | ( | Eina_Bool | enable,
|  | Eina_Bool | transition
| ) |  |

Enable/Disable the title area with transition effect.

When the title area is disabled, then the controls would be hidden so as to expand the content area to full-size.

See also
  also elm_naviframe_item_title_enabled_get()
  also elm_naviframe_item_title_visible_set()

Parameters

  [in] | enable | If `EINA_TRUE`, title area will be enabled, disabled otherwise
  [in] | transition | If `EINA_TRUE`, transition effect of the title will be visible, invisible otherwise

Referenced by elm_naviframe_item_title_enabled_set().

EOAPI Eina_List* elm_obj_naviframe_items_get | ( | void |  | ) |

Get a list of all the naviframe items.

Returns
  A list of naviframe items, Elm_Object_Item, or `NULL` on failure.

Note
  The returned list MUST be freed.

Referenced by elm_naviframe_items_get().

EOAPI Eina_Bool elm_obj_naviframe_prev_btn_auto_pushed_get | ( | void |  | ) |

Get a value whether prev button(back button) will be auto pushed or not.

Returns
  If `EINA_TRUE`, prev button will be auto pushed.

See also
  also elm_naviframe_item_push() elm_naviframe_prev_btn_auto_pushed_set()

Referenced by elm_naviframe_prev_btn_auto_pushed_get().

EOAPI void elm_obj_naviframe_prev_btn_auto_pushed_set | ( | Eina_Bool | auto_pushed | ) |

Set creating prev button automatically or not.

See also
  also elm_naviframe_item_push()

Parameters

  [in] | auto_pushed | If `EINA_TRUE`, the previous button(back button) will be created internally when you pass the `NULL` to the prev_btn parameter in elm_naviframe_item_push

Referenced by elm_naviframe_prev_btn_auto_pushed_set().

EOAPI Elm_Object_Item* elm_obj_naviframe_top_item_get | ( | void |  | ) |

Get a top item on the naviframe stack.

Returns
  The top item on the naviframe stack or `NULL`, if the stack is empty

Referenced by elm_naviframe_top_item_get().